{ pkgs ? import <nixpkgs> {} }:

let
  result = pkgs.lib.evalModules {
    args.pkgs = pkgs;
    modules = [
      ./options.nix
      ./legacy.nix
      ./device-templates.nix
    ];
  };
in
builtins.foldl' (config: warnings:
  if warnings == []
  then config
  else
    builtins.trace "WARNING: ${builtins.head warnings}" config
) result.config result.config.warnings
